Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/NegativeToZero.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/NegativeToZero.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/NegativeToZero.cs	(revision 14602)
@@ -0,0 +1,26 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class NegativeToZero : BenchmarkSuiteDataDescriptor<long[], long[]> {
+    private const string displayMame = "Negative To Zero";
+    private const string description = "Given a vector of integers, return the vector where all negative integers have been replaced by 0.";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override long[] ConvertInput(string[] input) {
+      return ConvertIntegers(input[0]);
+    }
+
+    public override long[] ConvertOutput(string[] output) {
+      return ConvertIntegers(output[0]);
+    }
+
+    public override IPushData CreatePushData(Example<long[], long[]>[] training, Example<long[], long[]>[] test) {
+      return new NegativeToZeroPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/NumberIo.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/NumberIo.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/NumberIo.cs	(revision 14602)
@@ -0,0 +1,28 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class NumberIo : BenchmarkSuiteDataDescriptor<double[], double> {
+    private const string displayMame = "NumberIO";
+    private const string description = " Given an integer and a float, print their sum.";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+
+    protected override int InputCount { get { return 2; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override double[] ConvertInput(string[] input) {
+      return input.Select(ConvertDouble).ToArray();
+    }
+
+    public override double ConvertOutput(string[] output) {
+      return ConvertDouble(output[0]);
+    }
+
+    public override IPushData CreatePushData(Example<double[], double>[] training, Example<double[], double>[] test) {
+      return new NumberIoPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/PigLatin.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/PigLatin.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/PigLatin.cs	(revision 14602)
@@ -0,0 +1,25 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class PigLatin : BenchmarkSuiteDataDescriptor<string, string> {
+    private const string displayMame = "Pig Latin";
+    private const string description = "Given a string containing lowercase words separated by single spaces, print the string with each word translated to pig Latin.Specifically, if a word starts with a vowel, it should have“ay”added to its end; otherwise, the first letter is moved to the end of the word, followed by “ay”";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 1; } }
+
+    public override string ConvertInput(string[] input) {
+      return input[0];
+    }
+
+    public override string ConvertOutput(string[] output) {
+      return output[0];
+    }
+
+    public override IPushData CreatePushData(Example<string, string>[] training, Example<string, string>[] test) {
+      return new PigLatinPushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/ReplaceSpaceWithNewLine.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/ReplaceSpaceWithNewLine.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/ReplaceSpaceWithNewLine.cs	(revision 14602)
@@ -0,0 +1,25 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+
+  public class ReplaceSpaceWithNewline : BenchmarkSuiteDataDescriptor<string, string[]> {
+    private const string displayMame = "Replace Space with Newline";
+    private const string description = "Given a string input, print the string, replacing spaces with newlines.Also, return the integer count of the non- whitespace characters. The input string will not have tabs or newlines.";
+
+    public override string Name { get { return displayMame; } }
+    public override string Description { get { return description; } }
+    protected override int InputCount { get { return 1; } }
+    protected override int OutputCount { get { return 2; } }
+
+    public override string ConvertInput(string[] input) {
+      return input[0];
+    }
+
+    public override string[] ConvertOutput(string[] output) {
+      return output;
+    }
+
+    public override IPushData CreatePushData(Example<string, string[]>[] training, Example<string, string[]>[] test) {
+      return new ReplaceSpaceWithNewlinePushData(training, test);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14602)
@@ -0,0 +1,119 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Problems.ProgramSynthesis</RootNamespace>
+    <AssemblyName>HeuristicLab.Problems.ProgramSynthesis</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <TargetFrameworkProfile />
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+    <LangVersion>5</LangVersion>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <RunPostBuildEvent>OnBuildSuccess</RunPostBuildEvent>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Collections-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Data-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Encodings.IntegerVectorEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Encodings.IntegerVectorEncoding-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Optimization-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Parameters-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Parameters-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Persistence-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Push\PushProblem.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Algorithms.PushGP\HeuristicLab.Algorithms.PushGP.csproj">
+      <Project>{368d1303-470c-4f31-91f2-0fad379daa45}</Project>
+      <Name>HeuristicLab.Algorithms.PushGP</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.BenchmarkSuite\HeuristicLab.BenchmarkSuite.csproj">
+      <Project>{22B5C087-CFC7-4D40-86C6-32FCF2CA921E}</Project>
+      <Name>HeuristicLab.BenchmarkSuite</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup />
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PostBuildEvent>
+    </PostBuildEvent>
+  </PropertyGroup>
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj.user
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj.user	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj.user	(revision 14602)
@@ -0,0 +1,10 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <ProjectView>ProjectFiles</ProjectView>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|AnyCPU'">
+    <StartAction>Program</StartAction>
+    <StartProgram>T:\BTSync\projects\svn\hl\trunk\sources\bin\HeuristicLab 3.3.exe</StartProgram>
+  </PropertyGroup>
+</Project>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs	(revision 14602)
@@ -26,8 +26,15 @@
   using HeuristicLab.PluginInfrastructure;
 
-  [Plugin("HeuristicLab.Problems.ProgramSynthesis.PushGP", "1.0")]
-  [PluginFile("HeuristicLab.Problems.ProgramSynthesis.PushGP.dll", PluginFileType.Assembly)]
+  [Plugin("HeuristicLab.Problems.ProgramSynthesis", "1.0")]
+  [PluginFile("HeuristicLab.Problems.ProgramSynthesis.dll", PluginFileType.Assembly)]
   [PluginFile("HeuristicLab.Algorithms.PushGP.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Problems.ProgramSynthesis.BenchmarkSuite", "1.0")]
   [PluginDependency("HeuristicLab.Random", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.IntegerVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class PushGpPlugin : PluginBase {
 
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/PushEvalutator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/PushEvalutator.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/PushEvalutator.cs	(revision 14602)
@@ -0,0 +1,12 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.PushGP.ProgramSynthesis {
+
+  public class PushEvalutator {
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/PushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/PushProblem.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/PushProblem.cs	(revision 14602)
@@ -0,0 +1,144 @@
+﻿using System;
+
+namespace HeuristicLab.Problems.PushGP.ProgramSynthesis {
+  using System.Collections.Generic;
+  using System.Linq;
+
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Data;
+  using HeuristicLab.Encodings.IntegerVectorEncoding;
+  using HeuristicLab.Optimization;
+  using HeuristicLab.Parameters;
+  //using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.Instances;
+
+  //[StorableClass]
+  [Creatable(CreatableAttribute.Categories.GeneticProgrammingProblems, Priority = 180)]
+  [Item("Push GP Problem", "")]
+  public class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding>, IProblemInstanceConsumer<IPushData> {
+
+    private readonly PushGpInterpreterPool pool = new PushGpInterpreterPool();
+    private IPushData pushData;
+
+    public PushProblem() {
+      this.InitParameters();
+
+      this.Encoding.Bounds[0, 0] = 0;
+      this.Encoding.Bounds[0, 1] = ExpressionTable.Count - 1;
+      this.Encoding.Length = this.pool.Configuration.MaxPointsInProgram;
+    }
+
+    #region Parameters
+
+    private const string EvalPushLimitParameterName = "EvalPushLimit";
+    private const string MaxProgramLengthParameterName = "MaxProgramLength";
+    private const string TopLevelPushCodeParameterName = "TopLevelPushCode";
+    private const string TopLevelPopCodeParameterName = "TopLevelPopCode";
+
+    private void InitParameters() {
+      this.Parameters.Add(new FixedValueParameter<IntValue>(EvalPushLimitParameterName, new IntValue(this.pool.Configuration.EvalPushLimit)));
+      this.Parameters.Add(new FixedValueParameter<IntValue>(MaxProgramLengthParameterName, new IntValue(this.pool.Configuration.MaxPointsInProgram)));
+      this.Parameters.Add(new FixedValueParameter<BoolValue>(TopLevelPushCodeParameterName, new BoolValue(this.pool.Configuration.TopLevelPushCode)) { Hidden = true });
+      this.Parameters.Add(new FixedValueParameter<BoolValue>(TopLevelPopCodeParameterName, new BoolValue(this.pool.Configuration.TopLevelPopCode)) { Hidden = true });
+    }
+
+    public IValueParameter<IntValue> EvalPushLimitParameter { get { return this.Parameters[EvalPushLimitParameterName] as ValueParameter<IntValue>; } }
+    public int EvalPushLimit
+    {
+      get { return this.pool.Configuration.EvalPushLimit; }
+      set
+      {
+        this.EvalPushLimitParameter.Value.Value = value;
+        this.pool.Configuration.EvalPushLimit = value;
+      }
+    }
+
+    public IValueParameter<IntValue> MaxProgramLengthParameter { get { return this.Parameters[MaxProgramLengthParameterName] as ValueParameter<IntValue>; } }
+
+    public int MaxProgramLength
+    {
+      get { return this.pool.Configuration.MaxPointsInProgram; }
+      set
+      {
+        this.MaxProgramLengthParameter.Value.Value = value;
+        this.Encoding.LengthParameter.Value.Value = value;
+        this.pool.Configuration.MaxPointsInProgram = value;
+      }
+    }
+
+    public IValueParameter<BoolValue> TopLevelPushParameter { get { return this.Parameters[TopLevelPushCodeParameterName] as ValueParameter<BoolValue>; } }
+
+    public bool TopLevelPushCode
+    {
+      get { return this.pool.Configuration.TopLevelPushCode; }
+      set
+      {
+        this.TopLevelPushParameter.Value.Value = value;
+        this.pool.Configuration.TopLevelPushCode = value;
+      }
+    }
+
+    public IValueParameter<BoolValue> TopLevelPopParameter { get { return this.Parameters[TopLevelPopCodeParameterName] as ValueParameter<BoolValue>; } }
+
+    public bool TopLevelPopCode
+    {
+      get { return this.pool.Configuration.TopLevelPopCode; }
+      set
+      {
+        this.TopLevelPushParameter.Value.Value = value;
+        this.pool.Configuration.TopLevelPopCode = value;
+      }
+    }
+
+    #endregion
+
+    // persistence
+    //[StorableConstructor]
+    public PushProblem(bool deserializing) : base(deserializing) { }
+
+    // cloning
+    public PushProblem(PushProblem original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override bool Maximization { get { return false; } }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      throw new NotImplementedException();
+    }
+
+    public override double Evaluate(Individual individual, IRandom random) {
+      var vector = individual.IntegerVector();
+      var program = MapToProgram(vector);
+      var results = new List<long>();
+
+      using (var interpreter = pool.GetInstance()) {
+        for (var i = 0; i < this.pushData.TrainingCount; i++) {
+          this.pushData.ApplyTrainingInput(interpreter, i);
+          interpreter.Run(program);
+
+          var diff = (long)this.pushData.CompareTrainingOutput(interpreter, i);
+          results.Add(diff);
+
+          interpreter.Clear();
+        }
+      }
+
+      return results.Count == 0 ? 0d : results.Average();
+    }
+
+    private static ExecExpandExpression MapToProgram(IntegerVector vector) {
+      var expressions = vector.Select(ExpressionTable.GetExpression);
+
+      return new ExecExpandExpression(expressions);
+    }
+
+    public void Load(IPushData data) {
+      this.pushData = data;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/PushProgram.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/PushProgram.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/PushProgram.cs	(revision 14602)
@@ -0,0 +1,58 @@
+﻿using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.PushGP.ProgramSynthesis {
+  using System.Drawing;
+
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Common;
+  using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+  public class PushProgram : ExecExpandExpression, ISymbolicExpressionTree {
+    public PushProgram(Expression[] state)
+      : base(state) {
+    }
+
+    public PushProgram(ExecExpandExpression origin)
+      : base(origin) {
+    }
+
+    public object Clone() {
+      throw new NotImplementedException();
+    }
+
+    public IDeepCloneable Clone(Cloner cloner) {
+      throw new NotImplementedException();
+    }
+
+    public string ItemName { get; private set; }
+
+    public string ItemDescription { get; private set; }
+
+    public Version ItemVersion { get; private set; }
+
+    public Image ItemImage { get; private set; }
+
+    public event EventHandler ItemImageChanged;
+
+    public event EventHandler ToStringChanged;
+
+    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesBreadth() {
+      throw new NotImplementedException();
+    }
+
+    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPrefix() {
+      throw new NotImplementedException();
+    }
+
+    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPostfix() {
+      throw new NotImplementedException();
+    }
+
+    public ISymbolicExpressionTreeNode Root { get; set; }
+
+    public int Length { get { return this.State.Length; } }
+
+    public new int Depth { get { return base.Depth; } }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14602)
@@ -0,0 +1,206 @@
+﻿namespace HeuristicLab.Tests.Benchmark.Problem {
+  using System;
+  using System.Linq;
+  using System.Threading.Tasks;
+
+  using HeuristicLab.Algorithms.PushGP.Data.Random;
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Generators;
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.Problems.Instances;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class ProblemTests {
+
+    private void Test(params IDataDescriptor[] descriptors) {
+      var instance = new BenchmarkSuitePushInstanceProvider();
+
+      foreach (var d in descriptors) {
+        var examples = instance.LoadData(d);
+      }
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void CountOdds() {
+      RandomWalk(new CountOdds());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void Checksum() {
+      RandomWalk(new Checksum());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void CollatzNumbers() {
+      RandomWalk(new CollatzNumbers());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void CompareStringLengths() {
+      RandomWalk(new CompareStringLengths());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void Digits() {
+      RandomWalk(new Digits());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void DoubleLetters() {
+      RandomWalk(new DoubleLetters());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void EvenSquares() {
+      RandomWalk(new EvenSquares());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void ForLoopIndex() {
+      RandomWalk(new ForLoopIndex());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void Grades() {
+      RandomWalk(new Grades());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void LastIndexOfZero() {
+      RandomWalk(new LastIndexOfZero());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void Median() {
+      RandomWalk(new Median());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void MirrorImage() {
+      RandomWalk(new MirrorImage());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void NegativeToZero() {
+      RandomWalk(new NegativeToZero());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void NumberIo() {
+      RandomWalk(new NumberIo());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void PigLatin() {
+      RandomWalk(new PigLatin());
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Medium")]
+    [TestCategory("ProblemTest")]
+    public void ReplaceSpaceWithNewLine() {
+      RandomWalk(new ReplaceSpaceWithNewline());
+    }
+
+    private static void RandomWalk(IDataDescriptor descriptor) {
+      var maxProgramSizeLimit = 1024;
+      var iterations = 1; //4000;
+      var best = double.MaxValue;
+      var globalExecCounter = 0;
+      var lockObj = new object();
+      var lockCount = new object();
+      RandomFactory.Seed = 1337;
+
+      Expression bestProgram = null;
+      var config = new Configuration { EvalPushLimit = 500 };
+      var pool = new PushGpInterpreterPool(config);
+
+      var instance = new BenchmarkSuitePushInstanceProvider();
+      var examples = instance.LoadData(descriptor);
+
+      Parallel.For(0, iterations, i => {
+        var execCounter = 0;
+        var program = CodeGenerator.RandomProgram(maxProgramSizeLimit);
+        var results = new double[examples.TrainingCount];
+
+        using (var interpreter = pool.GetInstance()) {
+          for (var j = 0; j < examples.TrainingCount; j++) {
+            examples.ApplyTrainingInput(interpreter, j);
+            interpreter.Run(program);
+
+            results[j] = examples.CompareTrainingOutput(interpreter, j);
+
+            execCounter += interpreter.ExecCounter;
+            interpreter.Clear();
+          }
+        }
+
+        lock (lockCount) {
+          globalExecCounter += execCounter;
+        }
+
+        var avg = results.Average();
+
+        if (avg >= best) return;
+
+        lock (lockObj) {
+          if (avg < best) {
+            best = avg;
+            bestProgram = program;
+          }
+        }
+      });
+
+      var resultsTest = new double[examples.TrainingCount];
+      Parallel.For(0, examples.TrainingCount, i => {
+        using (var interpreter = pool.GetInstance()) {
+          examples.ApplyTestInput(interpreter, i);
+          interpreter.Run(bestProgram);
+
+          resultsTest[i] = examples.CompareTestOutput(interpreter, i);
+        }
+      });
+
+      var averageTestResult = resultsTest.Average();
+
+      Console.WriteLine("Best Training: {0}", best);
+      Console.WriteLine("Test: {0}", averageTestResult);
+      Console.WriteLine("Best trainig program: {0}", bestProgram);
+      Console.WriteLine("ExecCounter: {0}", globalExecCounter);
+    }
+  }
+}
